{  97120V3.PAS                                                              }
{  1997-12-06 kooliolmpiaadi vanema rhma 3. lesande lahendus             }
{  Autor: Ahto Truu                                                         }

var
   f : text;
   xc, yc, r : real;
   x, y : array [1..5] of real;
   lx, ly, ld : real;
   kx, ky, kd : real;

{ leiab ruudu puuduvad tipud }
procedure tipud;
var vx, vy : real;
begin
   vx := x[3] - x[1];
   vy := y[3] - y[1];
   x[2] := x[1] + (vx + vy) / 2;
   y[2] := y[1] + (vy - vx) / 2;
   x[4] := x[1] + (vx - vy) / 2;
   y[4] := y[1] + (vy + vx) / 2;
   x[5] := x[1]; y[5] := y[1];
end;

{ kas antud punkt on ruudu sees? }
function ruudus (xx, yy : real) : boolean;
var d, vx, vy : real;
begin
   d := (x[2] - x[1]) * (y[4] - y[1]) - (y[2] - y[1]) * (x[4] - x[1]);
   vx := ((xx - x[1]) * (y[4] - y[1]) - (yy - y[1]) * (x[4] - x[1])) / d;
   vy := ((x[2] - x[1]) * (yy - y[1]) - (y[2] - y[1]) * (xx - x[1])) / d;
   ruudus := not ((0 > vx) or (vx > 1) or (0 > vy) or (vy > 1));
end;

{ ringi keskpunktile lhim ruudu serva punkt }
procedure lahim (var lx, ly, ld : real);
var vx, vy, k, d : real; i : integer;
begin
   lx := x[5]; ly := y[5]; ld := sqrt (sqr (xc - lx) + sqr (yc - ly));
   for i := 1 to 4 do begin
      vx := x[i + 1] - x[i]; vy := y[i + 1] - y[i];
      k := (vx * (xc - x[i]) + vy * (yc - y[i])) / (sqr (vx) + sqr (vy));
      if k < 0 then k := 0; if k > 1 then k := 1;
      d := sqrt (sqr (xc - x[i] - k * vx) + sqr (yc - y[i] - k * vy));
      if d < ld then begin
         lx := x[i] + k * vx; ly := y[i] + k * vy; ld := d;
      end;
   end;
end;

{ ringi keskpunktist kaugeim ruudu tipp }
procedure kaugeim (var kx, ky, kd : real);
var d : real; i : integer;
begin
   kd := 0;
   for i := 1 to 4 do begin
      d := sqrt (sqr (x[i] - xc) + sqr (y[i] - yc)); 
      if d > kd then begin
         kx := x[i]; ky := y[i]; kd := d;
      end;
   end;
end;

begin
   assign (f, 'input.txt'); reset (f);
   readln (f, xc, yc, r);
   readln (f, x[1], y[1], x[3], y[3]);
   close (f);

   tipud;

   assign (f, 'output.txt'); rewrite (f);

   if ruudus (xc, yc) then
      writeln (f, xc :15:6, yc :15:6)
   else begin
      lahim (lx, ly, ld);
      if ld > r then
         writeln (f, 'EI OLE')
      else begin
         lx := xc + (lx - xc) * (r + ld) / (2 * ld);
         ly := yc + (ly - yc) * (r + ld) / (2 * ld);
         writeln (f, lx :15:6, ly :15:6);
      end;
   end;

   if ruudus (xc, yc) then begin
      lahim (lx, ly, ld);
      if ld < r then begin
         lx := xc + (lx - xc) * (r + ld) / (2 * ld);
         ly := yc + (ly - yc) * (r + ld) / (2 * ld);
         writeln (f, lx :15:6, ly :15:6);
      end else
         writeln (f, 'EI OLE');
   end else
      writeln (f, xc :15:6, yc :15:6);

   kaugeim (kx, ky, kd);
   if kd > r then
      writeln (f, kx :15:6, ky :15:6)
   else
      writeln (f, 'EI OLE');

   writeln (f, 2000.0 :15:6, 2000.0 :15:6);

   close (f);
end.
