{$I-}

type
   mat = array [0..1, 0..1] of real;

procedure mul (var m : mat; m1, m2 : mat);
var i, j : byte;
begin
   for i := 0 to 1 do
      for j := 0 to 1 do
         m[i, j] := m1[i, 0] * m2[0, j] + m1[i, 1] * m2[1, j];
end;

var
   f : text;
   h, v, p : real;
   n : longint;
   a, b : mat;
   k1, k2 : real;

begin
   if paramcount <> 2 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail');
      exit;
   end;

   assign (f, 'input.txt'); reset (f);
   readln (f, h, v, p);
   readln (f, n);
   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      exit;
   end;

   a[0, 0] := 1;
   a[0, 1] := 0;
   a[1, 0] := 0;
   a[1, 1] := 1;

   b[0, 0] := 1 - v * p / (h * (v + p));
   b[0, 1] := v * p / (h * (v + p));
   b[1, 0] := p / (v + p);
   b[1, 1] := v / (v + p);

   while n > 0 do begin
      if n and 1 > 0 then
         mul (a, a, b);
      n := n shr 1;
      mul (b, b, b);
   end;

   assign (f, paramstr(2)); reset (f);
   readln (f, k1, k2);
   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      exit;
   end;

   if abs (k1 - 100 * a[0, 0]) > 0.005 then
      writeln ('1. Vale vastus')
   else
      writeln ('1. Korras');

   if abs (k2 - 100 * a[1,0]) > 0.005 then
      writeln ('2. Vale vastus')
   else
      writeln ('2. Korras');
end.
