{$I-,N+,E-}

var
   f : text;
   xc, yc, r : real;
   x, y : array [1..5] of real;

{ lahutab stringi kaheks reaalarvuks }
function arvudeks (s : string; var xx, yy : real) : boolean;
var i1, i2, i3, i4, i : integer;
begin
   arvudeks := false; s := s + ' ';
   i1 := 1;
   while (i1 < length (s)) and (s[i1] = ' ') do i1 := i1 + 1;
   if s[i1] = ' ' then exit;
   i2 := i1 + 1;
   while (i2 < length (s)) and (s[i2] <> ' ') do i2 := i2 + 1;
   if s[i2] <> ' ' then exit;
   i3 := i2 + 1;
   while (i3 < length (s)) and (s[i3] = ' ') do i3 := i3 + 1;
   if s[i3] = ' ' then exit;
   i4 := i3 + 1;
   while (i4 < length (s)) and (s[i4] <> ' ') do i4 := i4 + 1;
   if s[i4] <> ' ' then exit;
   for i := i4 + 1 to length (s) do if s[i] <> ' ' then exit;
   val (copy (s, i1, i2 - i1), xx, i); if i <> 0 then exit;
   val (copy (s, i3, i4 - i3), yy, i); if i <> 0 then exit;
   arvudeks := true;
end;

{ leiab ruudu puuduvad tipud }
procedure tipud;
var vx, vy : real;
begin
   vx := x[3] - x[1]; vy := y[3] - y[1];
   x[2] := x[1] + (vx + vy) / 2; y[2] := y[1] + (vy - vx) / 2;
   x[4] := x[1] + (vx - vy) / 2; y[4] := y[1] + (vy + vx) / 2;
   x[5] := x[1]; y[5] := y[1];
end;

{ kas antud punkt on ringi sees? }
function ringis (xx, yy : real) : boolean;
begin
   ringis := not (sqr (xx - xc) + sqr (yy - yc) > sqr (r));
end;

{ kas antud punkt on ruudu sees? }
function ruudus (xx, yy : real) : boolean;
var d, vx, vy : real;
begin
   d := (sqr (x[3] - x[1]) + sqr (y[3] - y[1])) / 2;
   vx := (xx - x[1]) * (y[4] - y[1]) - (yy - y[1]) * (x[4] - x[1]);
   vy := (x[2] - x[1]) * (yy - y[1]) - (y[2] - y[1]) * (xx - x[1]);
   ruudus := not ((vx < 0) or (vx > d) or (vy < 0) or (vy > d));
end;

{ ringi keskpunkti kaugus lhimast ruudu serva punktist }
function lahimani : real;
var ld, vx, vy, k, d : real; i : integer;
begin
   ld := sqrt (sqr (xc - x[5]) + sqr (yc - y[5]));
   for i := 1 to 4 do begin
      vx := x[i + 1] - x[i]; vy := y[i + 1] - y[i];
      k := (vx * (xc - x[i]) + vy * (yc - y[i])) / (sqr (vx) + sqr (vy));
      if k < 0 then k := 0; if k > 1 then k := 1;
      d := sqrt (sqr (xc - x[i] - k * vx) + sqr (yc - y[i] - k * vy));
      if d < ld then ld := d;
   end;
   lahimani := ld;
end;

{ ringi keskpunkti kaugus kaugeimast ruudu tipust }
function kaugeimani : real;
var kd, d : real; i : integer;
begin
   kd := 0;
   for i := 1 to 4 do begin
      d := sqrt (sqr (x[i] - xc) + sqr (y[i] - yc));
      if d > kd then kd := d;
   end;
   kaugeimani := kd;
end;

var
   s : string;
   xx, yy : real;

begin
   if paramcount <> 2 then begin
      writeln ('Sntaks on: ', paramstr (0), ' sisendfail vljundfail');
      exit;
   end;

   assign (f, paramstr (1)); reset (f);
   readln (f, xc, yc, r);
   readln (f, x[1], y[1], x[3], y[3]);
   close (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (1), ' lugemisel');
      exit;
   end;

   tipud;

   assign (f, paramstr(2)); reset (f);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      exit;
   end;

   readln (f, s);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      exit;
   end;
   if not ruudus (xc, yc) and (lahimani > r) then
      if s = 'EI OLE' then
         writeln ('1. Korras')
      else
         writeln ('1. Vale vastus')
   else
      if not arvudeks (s, xx, yy) then
         writeln ('1. Vale vastus')
      else
         if not ringis (xx, yy) or not ruudus (xx, yy) then
            writeln ('1. Vale vastus')
         else
            writeln ('1. Korras');

   readln (f, s);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      exit;
   end;
   if ruudus (xc, yc) and not (lahimani < r) then
      if s = 'EI OLE' then
         writeln ('2. Korras')
      else
         writeln ('2. Vale vastus')
   else
      if not arvudeks (s, xx, yy) then
         writeln ('2. Vale vastus')
      else
         if not ringis (xx, yy) or ruudus (xx, yy) then
            writeln ('2. Vale vastus')
         else
            writeln ('2. Korras');

   readln (f, s);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      exit;
   end;
   if not (kaugeimani > r) then
      if s = 'EI OLE' then
         writeln ('3. Korras')
      else
         writeln ('3. Vale vastus')
   else
      if not arvudeks (s, xx, yy) then
         writeln ('3. Vale vastus')
      else 
         if ringis (xx, yy) or not ruudus (xx, yy) then
            writeln ('3. Vale vastus')
         else
            writeln ('3. Korras');

   readln (f, s);
   if ioresult > 0 then begin
      writeln ('Viga faili ', paramstr (2), ' lugemisel');
      exit;
   end;
   if not arvudeks (s, xx, yy) then
      writeln ('4. Vale vastus')
   else
      if ringis (xx, yy) or ruudus (xx, yy) then
         writeln ('4. Vale vastus')
      else
         writeln ('4. Korras');

   close (f);
end.
